<?php

declare(strict_types=1);

namespace App\Repository;

final class TblNotificacionUsuarioRepository
{
    private \PDO $database;

    public function __construct(\PDO $database)
    {
        $this->database = $database;
    }

    public function getDb(): \PDO
    {
        return $this->database;
    }

    public function checkAndGet(int $TblNotificacionUsuarioId): object
    {
        $query = 'SELECT * FROM `TblNotificacionUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionUsuarioId);
        $statement->execute();
        $TblNotificacionUsuario = $statement->fetchObject();
        if (! $TblNotificacionUsuario) {
            throw new \Exception('TblNotificacionUsuario not found.', 404);
        }

        return $TblNotificacionUsuario;
    }

    public function getAll(): array
    {
        $query = 'SELECT * FROM `TblNotificacionUsuario` ORDER BY `id`';
        $statement = $this->getDb()->prepare($query);
        $statement->execute();

        return (array) $statement->fetchAll();
    }

    public function create(object $TblNotificacionUsuario): object
    {
        $query = 'INSERT INTO `TblNotificacionUsuario` (`IdNotificacion`, `FechaNotificacion`, `Activa`, `IdUsuario`, `field1`, `field2`, `field3`, `field4`, `field5`) VALUES (:IdNotificacion, :FechaNotificacion, :Activa, :IdUsuario, :field1, :field2, :field3, :field4, :field5)';
        $statement = $this->getDb()->prepare($query);
//         $statement->bindParam('id', $TblNotificacionUsuario->id);
//         $statement->bindParam('fecha', $TblNotificacionUsuario->fecha);
        $statement->bindParam('IdNotificacion', $TblNotificacionUsuario->IdNotificacion);
        $statement->bindParam('FechaNotificacion', $TblNotificacionUsuario->FechaNotificacion);
        $statement->bindParam('Activa', $TblNotificacionUsuario->Activa);
        $statement->bindParam('IdUsuario', $TblNotificacionUsuario->IdUsuario);
        $statement->bindParam('field1', $TblNotificacionUsuario->field1);
        $statement->bindParam('field2', $TblNotificacionUsuario->field2);
        $statement->bindParam('field3', $TblNotificacionUsuario->field3);
        $statement->bindParam('field4', $TblNotificacionUsuario->field4);
        $statement->bindParam('field5', $TblNotificacionUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $this->getDb()->lastInsertId());
    }

    public function update(object $TblNotificacionUsuario, object $data): object
    {
        if (isset($data->fecha)) {
            $TblNotificacionUsuario->fecha = $data->fecha;
        }
        if (isset($data->IdNotificacion)) {
            $TblNotificacionUsuario->IdNotificacion = $data->IdNotificacion;
        }
        if (isset($data->FechaNotificacion)) {
            $TblNotificacionUsuario->FechaNotificacion = $data->FechaNotificacion;
        }
        if (isset($data->Activa)) {
            $TblNotificacionUsuario->Activa = $data->Activa;
        }
        if (isset($data->IdUsuario)) {
            $TblNotificacionUsuario->IdUsuario = $data->IdUsuario;
        }
        if (isset($data->field1)) {
            $TblNotificacionUsuario->field1 = $data->field1;
        }
        if (isset($data->field2)) {
            $TblNotificacionUsuario->field2 = $data->field2;
        }
        if (isset($data->field3)) {
            $TblNotificacionUsuario->field3 = $data->field3;
        }
        if (isset($data->field4)) {
            $TblNotificacionUsuario->field4 = $data->field4;
        }
        if (isset($data->field5)) {
            $TblNotificacionUsuario->field5 = $data->field5;
        }

        $query = 'UPDATE `TblNotificacionUsuario` SET `fecha` = :fecha, `IdNotificacion` = :IdNotificacion, `FechaNotificacion` = :FechaNotificacion, `Activa` = :Activa, `IdUsuario` = :IdUsuario, `field1` = :field1, `field2` = :field2, `field3` = :field3, `field4` = :field4, `field5` = :field5 WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionUsuario->id);
        $statement->bindParam('fecha', $TblNotificacionUsuario->fecha);
        $statement->bindParam('IdNotificacion', $TblNotificacionUsuario->IdNotificacion);
        $statement->bindParam('FechaNotificacion', $TblNotificacionUsuario->FechaNotificacion);
        $statement->bindParam('Activa', $TblNotificacionUsuario->Activa);
        $statement->bindParam('IdUsuario', $TblNotificacionUsuario->IdUsuario);
        $statement->bindParam('field1', $TblNotificacionUsuario->field1);
        $statement->bindParam('field2', $TblNotificacionUsuario->field2);
        $statement->bindParam('field3', $TblNotificacionUsuario->field3);
        $statement->bindParam('field4', $TblNotificacionUsuario->field4);
        $statement->bindParam('field5', $TblNotificacionUsuario->field5);

        $statement->execute();

        return $this->checkAndGet((int) $TblNotificacionUsuario->id);
    }

    public function delete(int $TblNotificacionUsuarioId): void
    {
        $query = 'DELETE FROM `TblNotificacionUsuario` WHERE `id` = :id';
        $statement = $this->getDb()->prepare($query);
        $statement->bindParam('id', $TblNotificacionUsuarioId);
        $statement->execute();
    }
}
